#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>

int
test1(void)
{
	int		ret = -1;
	void		*dl1_lib, *dl2_lib;
	void		*(*func1)(void);
	void		(*func2)(void);

	dl1_lib = dlopen("dl1.so", RTLD_NOW | RTLD_GLOBAL);
	if (dl1_lib == NULL)
		goto fini;

	func1 = dlfunc(dl1_lib, "test_dl1");
	if (func1 == NULL)
		goto fini;

	func2 = dlfunc(dl1_lib, "test_dl2");
	if (func2 == NULL)
		goto fini;

	func2();
	ret = 0;

fini:
	if (ret)
		printf("dlopen/dlsym error: %s\n", dlerror());
	if (dl1_lib)
		dlclose(dl1_lib);
	if (dl2_lib)
		dlclose(dl2_lib);

	return (ret);
}

int
test2(void)
{
	int		ret = -1;
	void		*dl1_lib, *dl2_lib;
	void		*(*func1)(void);
	void		(*func2)(void);

	dl1_lib = dlopen("dl1.so", RTLD_NOW | RTLD_GLOBAL);
	if (dl1_lib == NULL)
		goto fini;

	func1 = dlfunc(dl1_lib, "test_dl1");
	if (func1 == NULL)
		goto fini;

	dl2_lib = func1();
	if (dl2_lib == NULL)
		goto fini;

	func2 = dlfunc(dl2_lib, "test_dl2");
	if (func2 == NULL)
		goto fini;

	func2();
	ret = 0;

fini:
	if (ret)
		printf("dlopen/dlsym error: %s\n", dlerror());
	if (dl1_lib)
		dlclose(dl1_lib);
	if (dl2_lib)
		dlclose(dl2_lib);

	return (ret);
}

int
main(void)
{

	if (test1())
		printf("Test 1 FAILED!!!\n\n");
	else
		printf("Test 1 PASSED!!!\n\n");

	if (test2())
		printf("Test 2 FAILED!!!\n\n");
	else
		printf("Test 2 PASSED!!!\n\n");

	return (0);
}
